# Copyright (C) 2013-2023, Hiroshi Izumi (izumi.h@aist.go.jp)
# This code is part of the Biopython distribution and governed by its
# license.  Please see the LICENSE file that should have been included
# as part of this package.

import os
import docx
#from docx.enum.text import WD_LINE_SPACING
from docx.shared import RGBColor
from docx.enum.text import WD_COLOR_INDEX

homedir = 'C:/SSSCview/FASTA_ssch_data'
outdir = 'C:/SSSCview/FASTA_ssch_data_docx'
flist = os.listdir('C:/SSSCview/FASTA_ssch_data')

os.chdir(homedir)
for i, samplen in enumerate(flist):
    fname = samplen.strip('\n')
    
    os.chdir(homedir)
    fa = open(fname, 'r')
    dataa1 = fa.readlines()
    fa.close()

    dataa1_l = len(dataa1)
    #nrows_l = int(dataa1_l/4)
    #print(dataa1_l)

    os.chdir(outdir)

    doc = docx.Document()

    #print (doc.paragraphs[0].runs)


    for i in range(1):
        tit_o = dataa1[i]
        seq_o = dataa1[i+1]
        sp2_o = dataa1[i+2]

        tit_s = tit_o.strip('\n')
        seq_s = seq_o.strip('\n')
        sp2_s = sp2_o.strip('\n')

        #seq_t,seq_r = seq_s.split('\t\t\t')
        #sp2_t,sp2_r = sp2_s.split('\t\t')
        #sp1_t,sp1_r = sp1_s.split('\t\t')
        #sp0_t,sp0_r = sp0_s.split('\t\t')
        #tit_t,tit_r = tit_s.split('_Model_0')
        #ti2_t,ti2_r = tit_s.split('Chain_')
        #tit_n = '%s_%s' % (tit_t, ti2_r)
        #tit_d = '%s.docx' % (tit_n)
        tit_t,tit_r = fname.split('.')
        tit_d = '%s.docx' % (tit_t)

        seq_l = list(seq_s)
        sp2_l = list(sp2_s)

        seq_e = '\t'.join(seq_l)
        sp2_e = '\t'.join(sp2_l)

        seq_len = len(seq_l)
        #print(seq_len)

        #rma_1 = []
        #for j, ele in enumerate(seq_l):
            #if sp2_l[j] == sp1_l[j] and sp2_l[j] == sp0_l[j]:
                #rma_1.append(1)
            #else:
                #rma_1.append(0)

        rma_2 = []
        for k, ele2 in enumerate(seq_l):
            if sp2_l[k] == 'S':
                rma_2.append(0)
            elif sp2_l[k] == 'H':
                rma_2.append(1)
            elif sp2_l[k] == 'T':
                rma_2.append(2)
            else:
                rma_2.append(3)
        #print(rma_2)

        #p1 = doc.add_paragraph()
        #for l in range(seq_len):
            #if rma_2[l] == 0:
                #p1r = p1.add_run(str(seq_s[l]))
                #p1r.font.highlight_color = WD_COLOR_INDEX.RED
            #elif rma_2[l] == 1:
                #p1r = p1.add_run(str(seq_s[l]))
                #p1r.font.highlight_color = WD_COLOR_INDEX.BLUE
                #p1r.font.color.rgb = RGBColor(255, 255, 0)
            #elif rma_2[l] == 2:
                #p1r = p1.add_run(str(seq_s[l]))
                #p1r.font.highlight_color = WD_COLOR_INDEX.BRIGHT_GREEN
                #p1r.font.color.rgb = RGBColor(255, 255, 0)
            #else:
                #p1r = p1.add_run(str(seq_s[l]))
                #p1r.font.highlight_color = WD_COLOR_INDEX.BRIGHT_GREEN
        #p1.add_run().add_break()
        p1 = doc.add_paragraph(seq_s)

        p2 = doc.add_paragraph()
        for l in range(seq_len):
            if rma_2[l] == 0:
                p2r = p2.add_run(str(sp2_s[l]))
                p2r.font.highlight_color = WD_COLOR_INDEX.YELLOW
            elif rma_2[l] == 1:
                p2r = p2.add_run(str(sp2_s[l]))
                p2r.font.highlight_color = WD_COLOR_INDEX.RED
                #p2r.font.color.rgb = RGBColor(255, 255, 0)
            elif rma_2[l] == 2:
                p2r = p2.add_run(str(sp2_s[l]))
                p2r.font.highlight_color = WD_COLOR_INDEX.BLUE
                p2r.font.color.rgb = RGBColor(255, 255, 0)            
            else:
                p2r = p2.add_run(str(sp2_s[l]))
                p2r.font.highlight_color = WD_COLOR_INDEX.BRIGHT_GREEN
        #p2.add_run().add_break()
        
        #p3 = doc.add_paragraph()
        #for l in range(seq_len):
            #if rma_2[l] == 0:
                #p3r = p3.add_run(str(sp1_s[l]))
                #p3r.font.highlight_color = WD_COLOR_INDEX.RED
            #elif rma_2[l] == 1:
                #p3r = p3.add_run(str(sp1_s[l]))
                #p3r.font.highlight_color = WD_COLOR_INDEX.BLUE
                #p3r.font.color.rgb = RGBColor(255, 255, 0)
            #elif rma_2[l] == 2:
                #p3r = p3.add_run(str(sp1_s[l]))
                #p3r.font.highlight_color = WD_COLOR_INDEX.BRIGHT_GREEN
            #else:
                #p3r = p3.add_run(str(sp1_s[l]))            
        #p3.add_run().add_break()
            
        #p4 = doc.add_paragraph()
        #for l in range(seq_len):
            #if rma_2[l] == 0:
                #p4r = p4.add_run(str(sp0_s[l]))
                #p4r.font.highlight_color = WD_COLOR_INDEX.RED
            #elif rma_2[l] == 1:
                #p4r = p4.add_run(str(sp0_s[l]))
                #p4r.font.highlight_color = WD_COLOR_INDEX.BLUE
                #p4r.font.color.rgb = RGBColor(255, 255, 0)
            #elif rma_2[l] == 2:
                #p4r = p4.add_run(str(sp0_s[l]))
                #p4r.font.highlight_color = WD_COLOR_INDEX.BRIGHT_GREEN
            #else:
                #p4r = p4.add_run(str(sp0_s[l]))
        #p4.add_run().add_break()

    doc.save(tit_d)


    doc = docx.Document(tit_d)

    #print (doc.paragraphs[0].runs)

    for paragraph in doc.paragraphs:
        #print (len(paragraph.runs))
        #paragraph.paragraph_format.line_spacing_rule = WD_LINE_SPACING.EXACTLY
        for run in paragraph.runs:
            run.font.size = docx.shared.Pt(8)
            run.font.name = "SimHei"

    doc.save(tit_d)

